// java FlowPaint $Z/n/Pricetest_tmp/image.77-90.ppm $D/Java/L/VIS/flow lipstic76.ppm
// for the 76 back to 37 part it was not necessary to use flipflow,
// I just ran it the same way on frames 37-76.
//
// To make the artwork:  gimp the background, layers&channels, make a new
// layer, change type to 'overlay', paint, then delete the background layer,
// set the background color to black, change from overlay to normal,
// flatten, save.   Copying the overlay to a new image and pasting does not
// work because the paste changes the location for some reason.
//
// dmconvert -d -v -f mpeg1v -p video,size=320x240 -n comp.####.ppm,start=37,end=20 comp.####.ppm out.mpg

import java.io.*;
import java.util.*;
import java.text.*;

import IF.FrameSpec;
import GR.*;
import zlib.*;
import gnu.*;

/**
 * To make the artwork:  gimp the background, layers&channels, make a new
 * layer, change type to 'overlay', paint, then delete the background layer,
 * set the background color to black,
 * flatten, save.   Copying the overlay to a new image and pasting does not
 * work because the paste changes the location for some reason.
 *
 * dmconvert -d -v -f mpeg1v -p video,size=320x240 -n comp.####.ppm,start=37,end=20 comp.####.ppm out.mpg
*/

public class FlowPaint
{

  public static void main(String[] cmdline)
  {
    try {
      Args args = new Args(cmdline);
      args.parse("+:str:plateseq:"+
		 "+:str:flowprefix, <frame>.####.flo is appended:"+
		 "+:str:artwork:");
      //"-flowflip:flg:flip flowfield direction";

      String platespec = args.getRequiredString(0);
      FrameSpec ps = new FrameSpec(platespec);

      String flowprefix = args.getRequiredString(1);

      String artpath = args.getRequiredString(2);

      int f1 = ps.getFirstFrame();
      int fn = ps.getLastFrame();

      gr[] art = grUtil.loadByExt(artpath);
      gr[] artwarp = grUtil.makecongruent("artwarp", art);

      gr matte = new grShort("matte", art[0].xres(), art[0].yres());
      gr mattewarp = grUtil.makecongruent("mattewarp", matte);
      // take r+g+b/3 lum as matte, scale back up a bit
      grOps.lum(art, matte);
      gr[] amatte = new gr[1];  amatte[0] = matte;  // warp needs nchannel
      grUtil.scale(amatte, 1.5f);
      gr[] amattewarp = new gr[1];  amattewarp[0] = mattewarp;

      DecimalFormat df = new DecimalFormat("0000");

      for( int f = f1; f <= fn; f++ ) {
	String fs = df.format(f);

	// read next frame in sequence,
	String platepath = ps.getFullPathOfFrame(f);
	gr[] curframe = grUtil.loadByExt(platepath);

	String flowframe = flowprefix +"."+ fs;
	float[][][] uv = FlowUtil.loadFlow(flowframe + ".flo");
	grFloatArr u = new grFloatArr("u", uv[0]);
	grFloatArr v = new grFloatArr("v", uv[1]);
	//grFloatArr u = grfArrUtil.load(flowframe + "_u.flt");
	//grFloatArr v = grfArrUtil.load(flowframe + "_v.flt");

	grOps.warp(art, artwarp, u.getData(), v.getData());
	grOps.warp(amatte, amattewarp, u.getData(), v.getData());
	grOps.comp(artwarp, curframe, mattewarp, curframe);

	grUtil.saveByExt(artwarp, "art."+fs+".ppm");
	grUtil.saveByExt(curframe, "comp."+fs+".ppm");

      } //loop

      System.exit(0);
    }
    catch(Exception x) { zliberror.die(x); }
  }
} //FlowPaint
