import java.io.*;

import GR.*;
import zlib.*;

public class FlowZoom
{
  public static void main(String[] cmdline)
  {
    if (cmdline.length != 3) {
      System.err.println("FlowZoom small.flo big.flo scale");
      System.err.println("zoom small into big by scale");
      System.exit(1);
    }

    try {
      float scale = Float.parseFloat(cmdline[2]);
      float[][][] f = FlowUtil.loadFlow(cmdline[0]);

      int yres = f[0].length;
      int yres2 = (int)Math.ceil(scale * yres);
      int xres = f[0][0].length;
      int xres2 = (int)Math.ceil(scale * xres);
      System.out.println("rescaling "+ xres+","+yres +" to " +
			 xres2+","+yres2);

      float[][][] f2 = new float[2][yres][xres];

      grfArrUtil.upresOpen(f[0], f2[0]);
      grfArrUtil.upresOpen(f[1], f2[1]);

      FlowUtil.saveFlow(cmdline[1], f2, false, xres2, yres2);
      System.exit(0);
    }
    catch(IOException x) { zliberror.die(x); }
  } //main

} //FlowZoom

